
package de.ivu.elect.presentation.kandidatur.action;

import de.ivu.elect.business.kandidatur.entity.Listenkandidatur;
import de.ivu.elect.jee.faces.FacesContextUtil;

public abstract class AbstractListenkandidaturZulassungBestaetigenNachtraeglichAmtsannahmeAction extends AbstractListenkandidaturZulassungAction {

  private static final long serialVersionUID = 1L;

  public AbstractListenkandidaturZulassungBestaetigenNachtraeglichAmtsannahmeAction() {
    super();
  }

  @Override
  protected String doIt(Listenkandidatur template) {
    listenkandidaturConversationSelect.setEntity(template);

    Listenkandidatur listenkandidatur = listenkandidaturConversationSelect.getEntity();

    if (listenkandidatur != null) {
      setKandidaturStatusBemerkung(listenkandidatur.getBemerkung());
    }

    return null; // Return to current page and display the dialog!
  }

  @Override
  public String getDialogName() {
    return getConfirmDialogName();
  }

  protected abstract String getConfirmDialogName();

  public String getDialogHeader() {
    return getLocalizedLabel();
  }

  public String getDialogMessage() {
    return getMessage("kandidatur.search.action." + getKandidaturStatus().name() + ".confirm.message");
  }

  // NOTE, dass diese Methode in /elect-core-jar/src/main/resources/META-INF/contracts/elect/kandidatur/listenkandidatur-search.xhtml aufgerufen wird!
  public void doActionConfirmed() {
    Listenkandidatur listenkandidatur = listenkandidaturConversationSelect.getEntity();

    String outcome = doActionConfirmed(listenkandidatur);

    listenkandidaturConversationSelect.clearEntity();

    refreshViewOnNonBlankResult(listenkandidatur, outcome);
  }

  private String doActionConfirmed(Listenkandidatur listenkandidatur) {
    if (listenkandidatur != null && isActionPossible(listenkandidatur)) {
      return super.doIt(listenkandidatur, getKandidaturStatus(), getKandidaturStatusBemerkung());
    }

    return FacesContextUtil.getCurrentViewId();
  }

  @Override
  public String getLabelKey() {
    return "kandidatur.search.action." + getKandidaturStatus().name();
  }
}
